local M = {}

--THIS IS NOT A SCENARIO EXTENSION!!
local function onScenarioChange(mgr)
    if mgr ~= nil then
        mgr:setRunning(false)
    end
    core_flowgraphManager.clearAllManagers()
end

-- Returns the MGR object
local function onScenarioLoaded(scenario, flowgraphName)
    -- get flow path
    local flowPath = "levels/" .. scenario.levelName .. "/flowgraphs/" .. flowgraphName
    local reverse = scenario.isReverse or false
    if reverse then
        flowPath = flowPath .. "rev"
    end
    flowPath = flowPath .. ".flow.json"
    
    -- load
    if FS:fileExists(flowPath) then
        print("Pacenotes Mod: Loading flowgraph '" .. flowPath .. "'")
        core_flowgraphManager.clearAllManagers()
        return core_flowgraphManager.loadManager(flowPath)
    end

    -- nothing found
    return nil
end

-- Passthru
local function onRaceStart(mgr)
    if mgr ~= nil then
        mgr:setRunning(true)
    end
end

local function onRaceResult(mgr)
    if mgr ~= nil then
        mgr:setRunning(false)
    end
end

M.onRaceStart = onRaceStart
M.onRaceResult = onRaceResult
M.onScenarioLoaded = onScenarioLoaded
M.onScenarioChange = onScenarioChange
return M