angular.module('beamng.apps')
.directive('pacenotes', [function () {
  return {
    templateUrl: '/ui/modules/apps/pacenotes/app.html',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
      scope.$on('$destroy', function () {
        $log.debug('<pacenotes> destroyed');
      });
        
        var script = document.createElement('script');
        script.src = '/ui/modules/apps/pacenotes/jquery-3.4.1.js';
        script.type = 'text/javascript';
        document.getElementsByTagName('head')[0].appendChild(script);

        function resizeNotes()
        {
            var elHeight = $(".note").height();
            $(".note").width(elHeight);
        }

        function isEmpty(str) {
            return (!str || 0 === str.length);
        }

        function addImagePaceNote(image, type)
        {
            var newElement = $('<div></div>');
            newElement.addClass("note");
            newElement.addClass(type + "_background");
            if(!isEmpty(image)) {
                newElement.addClass("pacenote_" + image);
            }
        
            //append and fade in
            var appendedElement = newElement.appendTo("#note_container");
            appendedElement.css({opacity: 0.0});
            appendedElement.fadeTo(750, 1.0);
        
            //fade out after 5s
            appendedElement.delay(5000).fadeOut(750, function() {
                appendedElement.remove();
            });
        
            resizeNotes();
        }

        scope.$on('Pacenote', function (event, args) {
          // logger.App.log(args);
          var type = args.type || 'normal';
          var image = args.image;
          addImagePaceNote(image, type);  
        });


    }
  };
}]);